##  Simple Script to take the existing TextMate documentation and convert it into a single page document that can be easily printed.
##  Probably contains a lot of bad Code uses, but it works for me at least. 
##  Created by Mats Persson [mats@imediatec.co.uk] 2005-10-06


# Check were the App is installed.
if File.exist?("/Applications/TextMate.app/")
  HELP_DOC_ROOT = File.expand_path("/Applications/TextMate.app/Contents/Resources/English.lproj/TextMate Help Book/")
else
  HELP_DOC_ROOT = File.expand_path("~/Applications/TextMate.app/Contents/Resources/English.lproj/TextMate Help Book/")
end

# now check if we have a print version of the documentation or not ?
if File.exists?("#{HELP_DOC_ROOT}/docs_print_version.html")
  # ok the file has been created already
  output = String.new
  output << "<html><head><title>TextMate Documentation</title></head><body>"
  output << "<p>The TextMate Print documentation was already created. You can view it in the Help Menu.</p>"
  output << "</body></html>"
  puts output

  # output << "<iframe src=\"tm-file://#{HELP_DOC_ROOT}/docs_print_version.html"
  # output << "\" width=\"100%\" height=\"95%\" scrolling=\"auto\"></iframe></body></html>"

else
  # here we need to create it

  # STEP 1:
  # grab all the files from the <li> in and read in the main index.html file
  @urls = Array.new
  @file_contents = Array.new
  
  # open the index.html file and process it
  IO.foreach("#{HELP_DOC_ROOT}/index.html") do |line|
    case line
    when /^\s*<li>/
      # <li><a href="Regex Syntax.html">Regular Expressions</a></li>
      re = /<li><a href="(.*)">(.*)<\/a><\/li>/
      md = re.match(line)
      # match the Titles and URLs into the array
      @urls << { :title => md[2], :file => md[1] }
      # add the line to the output
      @file_contents << line
    when /^\s*<h1>(.*)<\/h1>/
     @file_contents << line.gsub(/<h1>(.*)<\/h1>/){'<h1>TextMate Help :: Print Version</h1>'}
    when /^\s*<\/body|html>/
      next
    when /^\s*<\/head>/
      # replace the 
      @file_contents << line.gsub(/<\/head>/){"<style type=\"text/css\">\n  a:link { color: #000; text-decoration: underline; }\n pre { border: 1px solid #333; padding: 10px; }\n</style>\n</head>"}
   else
     @file_contents << line
   end     
  end

  
  # STEP 2
  # create the content for the full print version of the document
  # now loop through all the files in the @urls hash
  @urls.each do |x|
    @file_contents << "\n\n<hr />\n\n<!-- begin #{x[:title]} -->\n\n<h1>#{x[:title]}</h1>\n"
    @file_contents << File.read("#{HELP_DOC_ROOT}/#{x[:file]}").gsub( %r{<html[^>]*>.*<body[^>]*>}im, '' ).gsub( %r{<\/body[^>]*>.*<\/html[^>]*>}im, '' )
    @file_contents << "\n\n<!-- end #{x[:title]} -->\n\n"
  end
  
  # STEP 3
  # add the bottom of the page  
  @file_contents << "\n\n<hr /><p>End print version</p>\n\n</body>\n</html>"

  # STEP 4
  # create the new docs_print_version.html file    
  f = File.new("#{HELP_DOC_ROOT}/docs_print_version.html", "w+")
  f.write(@file_contents)
  f.close

  # STEP 5
  # add the Print Page to the main index file.
  @index_file = Array.new
  IO.foreach("#{HELP_DOC_ROOT}/index.html") do |line|
    if line =~ /^\s*<\/ul>/
      @index_file << line.gsub( /^\s*<\/ul>/, "</ul>\n\n<p><a href=\"docs_print_version.html\">Single Page Print Version</a></p>" )
    else
      @index_file << line
    end
  end
  f = File.new("#{HELP_DOC_ROOT}/index.html", "w+")
  f.write(@index_file)
  f.close
 
  # STEP 6
  # output the results
  
  output = String.new
  output << "<html><head><title>TextMate Documentation</title></head><body>"
  output << "<p>The TextMate Print documentation was successfully created. You can view it in the Help Menu.</p>"
  output << "</body></html>"
  puts output

end